'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = decode;

var _hessian = require('hessian.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RESPONSE_OK = 20;
var RESPONSE_WITH_EXCEPTION = 0;
var RESPONSE_VALUE = 1;
var RESPONSE_NULL_VALUE = 2;

function decode(heap) {
  var flag = void 0,
      result = void 0;

  if (heap[3] !== RESPONSE_OK) {
    return _promise2.default.resolve(heap.slice(18, heap.length - 1).toString());
  }

  try {
    result = new _hessian.DecoderV2(heap.slice(16, heap.length));
    flag = result.readInt();

    switch (flag) {
      case RESPONSE_NULL_VALUE:
        return _promise2.default.resolve(null);

      case RESPONSE_VALUE:
        return _promise2.default.resolve(result.read());

      case RESPONSE_WITH_EXCEPTION:
        var e = result.read();
        return _promise2.default.reject(e instanceof Error ? e : new Error(e));

      default:
        return _promise2.default.reject(new Error('Unknown result flag, expect \'0\' \'1\' \'2\', get ' + flag));
    }
  } catch (err) {
    return _promise2.default.reject(err);
  }
}
module.exports = exports['default'];