'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _net = require('net');

var _net2 = _interopRequireDefault(_net);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _nodeZookeeperClient = require('node-zookeeper-client');

var _nodeZookeeperClient2 = _interopRequireDefault(_nodeZookeeperClient);

var _ip = require('ip');

var _ip2 = _interopRequireDefault(_ip);

var _service = require('./service');

var _service2 = _interopRequireDefault(_service);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Dubbo = function () {
  function Dubbo(_ref) {
    var _this = this;

    var application = _ref.application,
        _ref$services = _ref.services,
        services = _ref$services === undefined ? {} : _ref$services,
        _ref$root = _ref.root,
        root = _ref$root === undefined ? 'dubbo' : _ref$root,
        _ref$version = _ref.version,
        version = _ref$version === undefined ? '2.5.3.6' : _ref$version,
        zookeeper = _ref.zookeeper;
    (0, _classCallCheck3.default)(this, Dubbo);


    this._root = root;
    this._version = version;
    this._connected = false;
    this._pendingServices = [];
    this._services = {};

    this._ip = _ip2.default.address();
    this._baseQuery = {
      application: application,
      category: 'consumers',
      check: 'false',
      dubbo: version,
      side: 'consumer'
    };

    var zk = this._zookeeper = _nodeZookeeperClient2.default.createClient(zookeeper.host, zookeeper);

    zk.connect();
    zk.once('connected', function () {
      _this._pendingServices.forEach(function (name) {
        _this._services[name].setup();
      });
    });

    (0, _keys2.default)(services).forEach(function (name) {
      var options = services[name];
      _this.register(name, options);
    });
  }

  // Get a service


  (0, _createClass3.default)(Dubbo, [{
    key: 'service',
    value: function service(name) {
      var existing = this._services[name];
      if (existing) {
        return existing;
      }

      var service = this._services[name] = new _service2.default(name);

      if (!this._connected) {
        this._pendingServices.push(name);
      } else {
        service.setup();
      }

      return service;
    }

    // Register a service

  }, {
    key: 'register',
    value: function register(name, options) {
      this.service(name).register({
        options: options,
        path: {
          consumer: this._consumerPath(options),
          provider: this._providerPath(options)
        },
        zookeeper: this._zookeeper,
        dubboVersion: this._version
      });
      return this;
    }
  }, {
    key: '_consumerPath',
    value: function _consumerPath(_ref2) {
      var _interface = _ref2.interface,
          version = _ref2.version,
          group = _ref2.group;


      var path = _url2.default.format({
        protocol: 'consumer',
        slashes: 'true',
        host: this._ip + '/' + _interface,
        query: (0, _extends3.default)({}, this._baseQuery, {
          interface: _interface,
          revision: version,
          version: version,
          group: group,
          timestamp: Date.now()
        })
      });

      return '/' + this._root + '/' + _interface + '/consumers/' + encodeURIComponent(path);
    }
  }, {
    key: '_providerPath',
    value: function _providerPath(_ref3) {
      var _interface = _ref3.interface;


      return '/' + this._root + '/' + _interface + '/providers';
    }
  }]);
  return Dubbo;
}();

exports.default = Dubbo;
module.exports = exports['default'];