'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.error = error;
exports.reject = reject;
exports.gte = gte;

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function error(message, code) {
  var e = new Error(message);
  e.code = code;
  return e;
}

function reject(message, code) {
  return _promise2.default.reject(error(message, code));
}

var STR_DOT = '.';

function cleanVersion(version) {
  var splitted = version.split(STR_DOT);
  var prefix = splitted.slice(0, 3);
  var suffix = splitted.slice(3);

  prefix.length = 3;

  return prefix.map(function (x) {
    return x || '0';
  }).join(STR_DOT) + (suffix.length ? '-' + suffix.join(STR_DOT) : '');
}

function gte(a, b) {
  return _semver2.default.gte(cleanVersion(a), cleanVersion(b));
}